searchNodes=[{"doc":"Documentation for Cased.","ref":"Cased.html","title":"Cased","type":"module"},{"doc":"Publish an audit event to Cased.Note: Uses GenServer.call/3 to send events to publisher processes.%{ action: &quot;credit_card.charge&quot;, amount: 2000, currency: &quot;usd&quot;, source: &quot;tok_amex&quot;, description: &quot;My First Test Charge (created for API docs)&quot;, credit_card_id: &quot;card_1dQpXqQwXxsQs9sohN9HrzRAV6y&quot; } |&gt; Cased.publish()","ref":"Cased.html#publish/2","title":"Cased.publish/2","type":"function"},{"doc":"Publish an audit event to Cased, raising an exception in the event of failure.","ref":"Cased.html#publish!/2","title":"Cased.publish!/2","type":"function"},{"doc":"","ref":"Cased.html#t:publish_opt/0","title":"Cased.publish_opt/0","type":"type"},{"doc":"Options when publishing.:publishers, the list of publisher pids (defaults to [Cased.Publisher.Datadog]).:handlers, the list of sensitive data handlers (defaults to []); see Cased.Sensitive.Handler.","ref":"Cased.html#t:publish_opts/0","title":"Cased.publish_opts/0","type":"type"},{"doc":"Data modeling a Cased audit trail.","ref":"Cased.AuditTrail.html","title":"Cased.AuditTrail","type":"module"},{"doc":"","ref":"Cased.AuditTrail.html#t:t/0","title":"Cased.AuditTrail.t/0","type":"type"},{"doc":"A client for the Cased API.","ref":"Cased.Client.html","title":"Cased.Client","type":"module"},{"doc":"Create a Cased client.ExamplesCreate a client with the policy key for your default audit trail:iex&gt; {:ok, client} = Cased.Client.create(key: &quot;policy_live_...&quot;)Create a client key with policy keys for specific audit trails:iex&gt; {:ok, client} = Cased.Client.create( ...&gt; keys: [ ...&gt; default: &quot;policy_live_...&quot;, ...&gt; users: &quot;policy_live_users...&quot; ...&gt; ] ...&gt; )If you plan on using the API to interact with policies themselves, you need to provide an :environment_key, for example:iex&gt; {:ok, client} = Cased.Client.create( ...&gt; key: &quot;policy_live_...&quot;, ...&gt; environment_key: &quot;environment_live_...&quot; ...&gt; ) ) Clients can be configured using runtime environment variables, your application configuration, hardcoded values, or any combination you choose. Just using runtime environment variable: iex&gt; {:ok, client} = Cased.Client.create( ...&gt; key: System.fetch_env!(&quot;CASED_POLICY_KEY&quot;) ...&gt; ) Just using application configuration: iex&gt; {:ok, client} = Cased.Client.create( ...&gt; key: Application.fetch_env!(:your_app, :cased_policy_key) ...&gt; ) Either/or: iex&gt; {:ok, client} = Cased.Client.create! ...&gt; (key: System.get_env(&quot;CASED_POLICY_KEY&quot;) || Application.fetch_env!(:your_app, :cased_policy_key) ...&gt; ) In the event your client is misconfigured, you&#39;ll get a `Cased.ConfigurationError` exception struct instead: Not providing required options: iex&gt; {:error, %Cased.ConfigurationError{}} = Cased.Client.create() You can also use `Cased.Client.create!/1` if you know you&#39;re passing the correct configuration options (otherwise it raises a `Cased.ConfigurationError` exception): iex&gt; client = Cased.Client.create!(key: &quot;policylive...&quot;) To simplify using clients across your application, consider writing a centralized function to handle constructing them: defmodule YourApp do # Rest of contents ... def cased_client dodefault_policy_key = System.get_env(&quot;CASED_POLICY_KEY&quot;) || Application.fetch_env!(:your_app, :cased_policy_key) Cased.Client.create!(key: default_policy_key) end end For reuse, consider caching your client structs in `GenServer` state, ETS, or another Elixir caching mechanism.","ref":"Cased.Client.html#create/1","title":"Cased.Client.create/1","type":"function"},{"doc":"Create a client or raise an exception.","ref":"Cased.Client.html#create!/1","title":"Cased.Client.create!/1","type":"function"},{"doc":"","ref":"Cased.Client.html#t:create_opt/0","title":"Cased.Client.create_opt/0","type":"type"},{"doc":"","ref":"Cased.Client.html#t:create_opts/0","title":"Cased.Client.create_opts/0","type":"type"},{"doc":"","ref":"Cased.Client.html#t:t/0","title":"Cased.Client.t/0","type":"type"},{"doc":"Used to set contextual data when publishing audit events with Cased.publish/2.Stored using the process dictionary, the context is tied to the current process.","ref":"Cased.Context.html","title":"Cased.Context","type":"module"},{"doc":"Add multiple values value to the context.ExampleAdding a :location and :http_method to the context:iex&gt; Cased.Context.merge(%{ iex&gt; location: &quot;https://example.com&quot;, iex&gt; http_method: :patch iex&gt; }) :okNote that the return value of merge/2 is :ok rather than what you might expect for, e.g., Map.merge/2, since we don't incur the cost of recalculating the full context when a value is added.","ref":"Cased.Context.html#merge/1","title":"Cased.Context.merge/1","type":"function"},{"doc":"Add multiple values to the context for the duration of a function execution.ExampleAdding a :location and :http_method to the context, temporarily:iex&gt; tmp_context = %{ iex&gt; location: &quot;https://example.com&quot;, iex&gt; http_method: :patch iex&gt; } iex&gt; Cased.Context.merge(tmp_context, fn -&gt; iex&gt; # Use Cased.publish/2 iex&gt; :your_return_value iex&gt; end) :your_return_valueNote that, unlike merge/1, the return value of merge/2 is the value of the last statement in your function.","ref":"Cased.Context.html#merge/2","title":"Cased.Context.merge/2","type":"function"},{"doc":"Add a value to the context.ExampleAdding a :location to the context:iex&gt; Cased.Context.put(:location, &quot;https://example.com&quot;) :okNote that the return value of put/2 is :ok rather than what you might expect for, e.g., Map.put/2, since we don't incur the cost of recalculating the full context when a value is added.","ref":"Cased.Context.html#put/2","title":"Cased.Context.put/2","type":"function"},{"doc":"Add a value to the context for the duration of a function execution.ExampleAdding a :location to the context, temporarily:iex&gt; Cased.Context.put(:location, &quot;https://example.com&quot;, fn -&gt; iex&gt; # Use Cased.publish/2 iex&gt; :your_return_value iex&gt; end) :your_return_valueNote that, unlike put/2, the return value of put/3 is the value of the last statement in your function.","ref":"Cased.Context.html#put/3","title":"Cased.Context.put/3","type":"function"},{"doc":"Reset the context data.ExamplesSetting a value in the context and then resetting it (note reset/0 returns :ok as context data was deleted):iex&gt; Cased.Context.put(:item, &quot;value&quot;) iex&gt; Cased.Context.to_map() %{item: &quot;value&quot;} iex&gt; Cased.Context.reset() :ok iex&gt; Cased.Context.to_map() %{}Resetting an empty context returns nil:iex&gt; Cased.Context.reset() nil","ref":"Cased.Context.html#reset/0","title":"Cased.Context.reset/0","type":"function"},{"doc":"Get the context as a map.ExampleSetting a value and retrieving the context as a map:iex&gt; Cased.Context.put(:location, &quot;https://example.com&quot;) :ok iex&gt; Cased.Context.to_map() %{location: &quot;https://example.com&quot;}","ref":"Cased.Context.html#to_map/0","title":"Cased.Context.to_map/0","type":"function"},{"doc":"Data modeling a Cased audit event.","ref":"Cased.Event.html","title":"Cased.Event","type":"module"},{"doc":"Build a request to retrieve an event.OptionsAll optional::audit_trail — The audit trail, used to ensure the event comes from the given audit trail.:key — A Cased policy key allowing access to events.If :key is omitted:If an :audit_trail is provided, the key configured on the client for that audit trail will be used.If an :audit_trail is not provided, the key configured on the client for the :default audit trail will be used.If :audit_trail is omitted, the :default audit trail is assumed.","ref":"Cased.Event.html#get/3","title":"Cased.Event.get/3","type":"function"},{"doc":"Build a request to retrieve events from an audit trail.Options:phrase — The search phrase.:audit_trail — The audit trail.:key — A Cased policy key allowing access to events.:variables — Cased Policy variables.:per_page — Number of results per page (default: 25).:page — Requested page (default: 1).If :key is omitted:If an :audit_trail is provided, the key configured on the client for that audit trail will be used.If an :audit_trail is not provided, the key configured on the client for the :default audit trail will be used.","ref":"Cased.Event.html#query/2","title":"Cased.Event.query/2","type":"function"},{"doc":"","ref":"Cased.Event.html#t:get_opt/0","title":"Cased.Event.get_opt/0","type":"type"},{"doc":"","ref":"Cased.Event.html#t:get_opts/0","title":"Cased.Event.get_opts/0","type":"type"},{"doc":"","ref":"Cased.Event.html#t:query_opt/0","title":"Cased.Event.query_opt/0","type":"type"},{"doc":"","ref":"Cased.Event.html#t:query_opts/0","title":"Cased.Event.query_opts/0","type":"type"},{"doc":"","ref":"Cased.Event.html#t:t/0","title":"Cased.Event.t/0","type":"type"},{"doc":"Data modeling a Cased export.","ref":"Cased.Export.html","title":"Cased.Export","type":"module"},{"doc":"Build a request to create an export of audit trail fields.OptionsThe following options are available::audit_trails — The list of audit trails to export:audit_trail — When passing a single audit trail, you can use this instead of :audit_trails.:fields — The fields to export:key — The Cased policy key allowing access to the audit trails and fields.The only required option is :fields.When both :audit_trail and :audit_trails are omitted, :audit_trail is assumed to be default.When :key is omitted, the key configured for the :audit_trail (or first of :audit_trails) in the client is used.ResponseWhen the resulting request is sucessfully executed by Cased.Request.run/2 or Cased.Request.run/1, a Cased.Export struct is returned.","ref":"Cased.Export.html#create/2","title":"Cased.Export.create/2","type":"function"},{"doc":"Build a request to retrieve data about an export.OptionsThe following options are available::key — A Cased policy key allowing access to the export.When :key is omitted, the key for the :default audit trail is used.ResponseWhen the resulting request is sucessfully executed by Cased.Request.run/2 or Cased.Request.run/1, a Cased.Export struct is returned.ExampleA basic example:iex&gt; client ...&gt; |&gt; Cased.Export.get(&quot;export_...&quot;) ...&gt; |&gt; Cased.Request.run! %Cased.Export{id: &quot;export_...&quot;, ...}","ref":"Cased.Export.html#get/3","title":"Cased.Export.get/3","type":"function"},{"doc":"Build a request to retrieve the export download.OptionsThe following options are available::key — A Cased policy key allowing access to the export.When :key is omitted, the key for the :default audit trail is used.ResponseWhen the resulting request is sucessfully executed by Cased.Request.run/2 or Cased.Request.run/1, a raw JSON string is returned. The JSON is not decoded automatically.ExampleA basic example:iex&gt; client ...&gt; |&gt; Cased.Export.get_download(&quot;export_...&quot;) ...&gt; |&gt; Cased.Request.run! &quot;{...}&quot;","ref":"Cased.Export.html#get_download/3","title":"Cased.Export.get_download/3","type":"function"},{"doc":"","ref":"Cased.Export.html#t:create_opt/0","title":"Cased.Export.create_opt/0","type":"type"},{"doc":"","ref":"Cased.Export.html#t:create_opts/0","title":"Cased.Export.create_opts/0","type":"type"},{"doc":"","ref":"Cased.Export.html#t:get_opt/0","title":"Cased.Export.get_opt/0","type":"type"},{"doc":"","ref":"Cased.Export.html#t:get_opts/0","title":"Cased.Export.get_opts/0","type":"type"},{"doc":"","ref":"Cased.Export.html#t:t/0","title":"Cased.Export.t/0","type":"type"},{"doc":"A publisher used to transmit audit events to Datadog via HTTP/S.","ref":"Cased.Publisher.Datadog.html","title":"Cased.Publisher.Datadog","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Cased.Publisher.Datadog.html#child_spec/1","title":"Cased.Publisher.Datadog.child_spec/1","type":"function"},{"doc":"Build publisher configuration.","ref":"Cased.Publisher.Datadog.html#init/1","title":"Cased.Publisher.Datadog.init/1","type":"function"},{"doc":"Start and link a publisher process.","ref":"Cased.Publisher.Datadog.html#start_link/1","title":"Cased.Publisher.Datadog.start_link/1","type":"function"},{"doc":"","ref":"Cased.Publisher.Datadog.html#t:config/0","title":"Cased.Publisher.Datadog.config/0","type":"type"},{"doc":"","ref":"Cased.Publisher.Datadog.html#t:init_opt/0","title":"Cased.Publisher.Datadog.init_opt/0","type":"type"},{"doc":"Available options to initialize the publisher.","ref":"Cased.Publisher.Datadog.html#t:init_opts/0","title":"Cased.Publisher.Datadog.init_opts/0","type":"type"},{"doc":"A publisher used to transmit audit events to Cased via HTTP/S.","ref":"Cased.Publisher.HTTP.html","title":"Cased.Publisher.HTTP","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Cased.Publisher.HTTP.html#child_spec/1","title":"Cased.Publisher.HTTP.child_spec/1","type":"function"},{"doc":"Build publisher configuration.","ref":"Cased.Publisher.HTTP.html#init/1","title":"Cased.Publisher.HTTP.init/1","type":"function"},{"doc":"Start and link a publisher process.","ref":"Cased.Publisher.HTTP.html#start_link/1","title":"Cased.Publisher.HTTP.start_link/1","type":"function"},{"doc":"","ref":"Cased.Publisher.HTTP.html#t:config/0","title":"Cased.Publisher.HTTP.config/0","type":"type"},{"doc":"","ref":"Cased.Publisher.HTTP.html#t:init_opt/0","title":"Cased.Publisher.HTTP.init_opt/0","type":"type"},{"doc":"Available options to initialize the publisher.","ref":"Cased.Publisher.HTTP.html#t:init_opts/0","title":"Cased.Publisher.HTTP.init_opts/0","type":"type"},{"doc":"Behaviour used to identify sensitive data.Implementing custom handlers only requires two functions:new/2, which is called by from_spec/1, passing any custom configuration.ranges/3, which is called for each value in an audit event by Cased.Sensitive.Processor.process/2.See Cased.Sensitive.RegexHandler and tests for example implementations.","ref":"Cased.Sensitive.Handler.html","title":"Cased.Sensitive.Handler","type":"behaviour"},{"doc":"Create a handler from a handler specification (commonly loaded from application config).ExamplesCreating a Cased.Sensitive.RegexHandler from the tuple specification:iex&gt; handler_spec = {Cased.Sensitive.RegexHandler, :username, ~r/@w+/} iex&gt; Cased.Sensitive.Handler.from_spec(handler) %Cased.Sensitive.RegexHandler{label: :username, regex: ~r/@w+/}","ref":"Cased.Sensitive.Handler.html#from_spec/1","title":"Cased.Sensitive.Handler.from_spec/1","type":"function"},{"doc":"Create a handler with a given label and custom configuration.","ref":"Cased.Sensitive.Handler.html#c:new/2","title":"Cased.Sensitive.Handler.new/2","type":"callback"},{"doc":"Extract Cased.Sensitive.Range structs for a given value at key.Note that value can be of any type; your implementation should return an empty list for any unsupported values.","ref":"Cased.Sensitive.Handler.html#c:ranges/3","title":"Cased.Sensitive.Handler.ranges/3","type":"callback"},{"doc":"","ref":"Cased.Sensitive.Handler.html#t:handler_module/0","title":"Cased.Sensitive.Handler.handler_module/0","type":"type"},{"doc":"A tuple structure used to declare the options for a handler.ExamplesConfiguring a Cased.Sensitive.RegexHandler to detect @-prefixed usernames:{Cased.Sensitive.RegexHandler, :username, ~r/@w+/}For your own, custom defined handlers:{MyApp.CustomHandler, :custom_label_for_handler, custom_configuration_for_handler}","ref":"Cased.Sensitive.Handler.html#t:spec/0","title":"Cased.Sensitive.Handler.spec/0","type":"type"},{"doc":"","ref":"Cased.Sensitive.Handler.html#t:t/0","title":"Cased.Sensitive.Handler.t/0","type":"type"},{"doc":"Processes audit events for sensitive data.","ref":"Cased.Sensitive.Processor.html","title":"Cased.Sensitive.Processor","type":"module"},{"doc":"Process an audit event, collecting any sensitive data found.ExamplesProcess an audit event, returning any sensitive data in a new :&quot;.cased&quot; key:iex&gt; audit_event = %{action: &quot;comment.create&quot;, body: &quot;Hi, @username&quot;} iex&gt; Cased.Sensitive.Processor.process(audit_event, handlers: [ iex&gt; {Cased.Sensitive.RegexHandler, :username, ~r/@\\w+/} iex&gt; ]) %{ &quot;.cased&quot;: %{ pii: %{ &quot;.body&quot; =&gt; [ %Cased.Sensitive.Range{ begin_offset: 4, end_offset: 13, key: :body, label: :username } ] } }, action: &quot;comment.create&quot;, body: &quot;Hi, @username&quot; }Return just the sensitive data:iex&gt; audit_event = %{action: &quot;comment.create&quot;, body: &quot;Hi, @username&quot;} iex&gt; Cased.Sensitive.Processor.process(audit_event, handlers: [ iex&gt; {Cased.Sensitive.RegexHandler, :username, ~r/@\\w+/} iex&gt; ], return: :pii) %{ &quot;.body&quot; =&gt; [ %Cased.Sensitive.Range{ begin_offset: 4, end_offset: 13, key: :body, label: :username } ] }","ref":"Cased.Sensitive.Processor.html#process/2","title":"Cased.Sensitive.Processor.process/2","type":"function"},{"doc":"","ref":"Cased.Sensitive.Processor.html#t:address/0","title":"Cased.Sensitive.Processor.address/0","type":"type"},{"doc":"","ref":"Cased.Sensitive.Processor.html#t:process_opt/0","title":"Cased.Sensitive.Processor.process_opt/0","type":"type"},{"doc":"","ref":"Cased.Sensitive.Processor.html#t:process_opts/0","title":"Cased.Sensitive.Processor.process_opts/0","type":"type"},{"doc":"A handler to mask strings by regular expression.ExamplesCreate a handler using Cased.Sensitive.Handler.from_spec/1:{Cased.Sensitive.RegexHandler, :username, ~r/@w+/} |&gt; Cased.Sensitive.Handler.from_spec()The same, created manually:Cased.Sensitive.RegexHandler.create(:username, ~r/@w+/)","ref":"Cased.Sensitive.RegexHandler.html","title":"Cased.Sensitive.RegexHandler","type":"module"},{"doc":"","ref":"Cased.Sensitive.RegexHandler.html#t:t/0","title":"Cased.Sensitive.RegexHandler.t/0","type":"type"},{"doc":"Used to mask sensitive string values.","ref":"Cased.Sensitive.String.html","title":"Cased.Sensitive.String","type":"module"},{"doc":"Check two sensitive strings for equality.ExamplesTwo strings with the same data and label are equivalent:iex&gt; string1 = Cased.Sensitive.String.new(&quot;text&quot;, label: &quot;username&quot;) iex&gt; string2 = Cased.Sensitive.String.new(&quot;text&quot;, label: &quot;username&quot;) iex&gt; Cased.Sensitive.String.equal?(string1, string2) trueIf the contents are different, two sensitive strings are not equal:iex&gt; string1 = Cased.Sensitive.String.new(&quot;text&quot;, label: &quot;username&quot;) iex&gt; string2 = Cased.Sensitive.String.new(&quot;txet&quot;, label: &quot;username&quot;) iex&gt; Cased.Sensitive.String.equal?(string1, string2) falseIf the labels are different, two sensitive strings are not equal:iex&gt; string1 = Cased.Sensitive.String.new(&quot;text&quot;, label: &quot;username&quot;) iex&gt; string2 = Cased.Sensitive.String.new(&quot;text&quot;, label: &quot;email&quot;) iex&gt; Cased.Sensitive.String.equal?(string1, string2) false","ref":"Cased.Sensitive.String.html#equal?/2","title":"Cased.Sensitive.String.equal?/2","type":"function"},{"doc":"Extract all {begin_offset, end_offset} values for matches of a given regular expression.ExamplesCased.Sensitive.String.new(&quot;Hello @username and @username&quot;) |&gt; Cased.Sensitive.String.matches(~r/@w+/) # =&gt; [{6, 15}, {20, 29}]","ref":"Cased.Sensitive.String.html#matches/2","title":"Cased.Sensitive.String.matches/2","type":"function"},{"doc":"Create a new Cased.Sensitive.String struct.ExampleCased.Sensitive.String.new(&quot;john@example.com&quot;, label: :email)","ref":"Cased.Sensitive.String.html#new/2","title":"Cased.Sensitive.String.new/2","type":"function"},{"doc":"","ref":"Cased.Sensitive.String.html#to_range/2","title":"Cased.Sensitive.String.to_range/2","type":"function"},{"doc":"","ref":"Cased.Sensitive.String.html#t:new_opt/0","title":"Cased.Sensitive.String.new_opt/0","type":"type"},{"doc":"","ref":"Cased.Sensitive.String.html#t:new_opts/0","title":"Cased.Sensitive.String.new_opts/0","type":"type"},{"doc":"","ref":"Cased.Sensitive.String.html#t:t/0","title":"Cased.Sensitive.String.t/0","type":"type"},{"doc":"Provides helper functions for testing Cased features.","ref":"Cased.TestHelper.html","title":"Cased.TestHelper","type":"module"},{"doc":"Asserts that one or more Cased events were published to publisher when evaluating fun.","ref":"Cased.TestHelper.html#assert_publishes_cased_events/2","title":"Cased.TestHelper.assert_publishes_cased_events/2","type":"function"},{"doc":"Asserts that a specific count of Cased events were published to publisher when evaluating fun.","ref":"Cased.TestHelper.html#assert_publishes_cased_events/3","title":"Cased.TestHelper.assert_publishes_cased_events/3","type":"function"},{"doc":"Asserts that no Cased events were published to publisher when evaluating fun.","ref":"Cased.TestHelper.html#assert_publishes_no_cased_events/2","title":"Cased.TestHelper.assert_publishes_no_cased_events/2","type":"function"},{"doc":"Captures Cased events published to publisher when evaluating fun.","ref":"Cased.TestHelper.html#capture_cased_events/2","title":"Cased.TestHelper.capture_cased_events/2","type":"function"},{"doc":"cased-elixirA Cased client for Elixir applications in your organization to publish audit trail events to Datadog Logs.","ref":"readme.html","title":"cased-elixir","type":"extras"},{"doc":"InstallationConfigurationUsagePublishing events to CasedMasking &amp; filtering sensitive informationContextTestingContribution Guidelines","ref":"readme.html#overview","title":"cased-elixir - Overview","type":"extras"},{"doc":"The package can be installed by adding cased to your list of dependencies in mix.exs:def deps do [ {:cased, &quot;~&gt; 1.0.0&quot;} ] end","ref":"readme.html#installation","title":"cased-elixir - Installation","type":"extras"},{"doc":"cased-elixir follows Elixir's Library Guidelines, avoiding the use of a global :cased application configuration in favor of more flexible, ad hoc configuration at runtime (using your own application configuration, environment variables, etc).For PublisherAdd a worker specification for Cased.Publisher.Datadog to your application's supervisor.The publisher accepts the following options::key — Your Datadog API key (required).:silence — Whether audit trail events will be discarded, rather than sent; useful for non-production usage (optional; defaults to false).:timeout — The request timeout, in milliseconds (optional; defaults to 15_000)You can source your configuration values from your application configuration, runtime environment variables, or hard-code them directly; the following is just an example:children = [ # Other workers... { Cased.Publisher.Datadog, key: System.get_env(&quot;DD_API_KEY&quot;) || Application.fetch_env!(:your_app, :datadog_api_key), silence: System.get_env(&quot;CASED_SILENCE&quot;) || Application.fetch_env!(:your_app, :cased_silence, false), } ] # Other config... Supervisor.start_link(children, opts)In the event you provide an invalid configuration, a Cased.ConfigurationError will be raised with details.","ref":"readme.html#configuration","title":"cased-elixir - Configuration","type":"extras"},{"doc":"Publishing events to CasedProvided you've configured the Cased publisher, use Cased.publish/1:iex&gt; %{ ...&gt; action: &quot;credit_card.charge&quot;, ...&gt; amount: 2000, ...&gt; currency: &quot;usd&quot;, ...&gt; source: &quot;tok_amex&quot;, ...&gt; description: &quot;My First Test Charge (created for API docs)&quot;, ...&gt; credit_card_id: &quot;card_1dQpXqQwXxsQs9sohN9HrzRAV6y&quot; ...&gt; } ...&gt; |&gt; Cased.publish() :ok:information_source: See the documentation for Cased.publish/2 for more options.Masking &amp; filtering sensitive informationIf you are handling sensitive information on behalf of your users, you should consider masking or filtering any sensitive information.You can do this manually by using Cased.Sensitive.String.new/2:iex&gt; %{ ...&gt; action: &quot;credit_card.charge&quot;, ...&gt; user: Cased.Sensitive.String.new(&quot;john@example.com&quot;, label: :email) ...&gt; } ...&gt; |&gt; Cased.publish() :okYou can also use handlers to find sensitive values for you automatically. Here's an example checking for usernames:iex&gt; username_handler = {Cased.Sensitive.RegexHandler, :username, ~r&lt;@\\w+&gt;} iex&gt; %{ ...&gt; action: &quot;comment.create&quot;, ...&gt; body: &quot;@username, I&#39;m not sure.&quot; ...&gt; } ...&gt; |&gt; Cased.publish(handlers: [username_handler]) :okIf you're regularly using the same handlers, consider storing them in your application config and defining your own function to use them in your application:defmodule MyApp do @doc &quot;&quot;&quot; Publish an audit event to Cased. &quot;&quot;&quot; @spec publish_to_cased(audit_event :: map()) :: :ok | {:error, any()} def publish_to_cased(audit_event) do handlers = Application.get_env(:my_app, :cased_handlers, []) audit_event |&gt; Cased.publish(handlers: handlers) end endFor more information, see the Cased.Sensitive.Handler module.ContextOne of the most easiest ways to publish detailed events to Cased is to push contextual information into the Cased context.Note that the Cased context is tied to the current process (it's actually stored in the process dictionary). Different process, different context.iex&gt; Cased.Context.merge(location: &quot;hostname.local&quot;) :ok iex&gt; %{ ...&gt; action: &quot;console.start&quot;, ...&gt; user: &quot;john&quot; ...&gt; } ...&gt; |&gt; Cased.publish() :okAny information stored using Cased.Context will be included any time an event is published.{ &quot;cased_id&quot;: &quot;5f8559cd-4cd9-48c3-b1d0-6eedc4019ec1&quot;, &quot;action&quot;: &quot;user.login&quot;, &quot;user&quot;: &quot;john&quot;, &quot;location&quot;: &quot;hostname.local&quot;, &quot;timestamp&quot;: &quot;2020-06-22T21:43:06.157336&quot; }You can provide Cased.Context.merge/2 a function and the context will only be present for the duration of the function execution:iex&gt; Cased.Context.merge(location: &quot;hostname.local&quot;) do ...&gt; # Will include { &quot;location&quot;: &quot;hostname.local&quot; } ...&gt; %{ ...&gt; action: &quot;console.start&quot;, ...&gt; user: &quot;john&quot; ...&gt; } ...&gt; |&gt; Cased.publish() ...&gt; end :ok iex&gt; # Will not include {&quot;location&quot;: &quot;hostname.local&quot;} iex&gt; %{ ...&gt; action: &quot;console.end&quot;, ...&gt; user: &quot;john&quot; ...&gt; } ...&gt; |&gt; Cased.publish() :ok(You can also use Cased.Context.put/2 and Cased.Context.put/3 for single-value additions to the context.)To reset the context, use Cased.Context.reset/0:iex&gt; Cased.Context.reset() :ok # or `nil` if no data was stored in the contextSee the Cased.Context module for more information.TestingSee Cased.TestHelper.","ref":"readme.html#usage","title":"cased-elixir - Usage","type":"extras"},{"doc":"Fork it ( https://github.com/cased/cased-elixir/fork )Create your feature branch (git checkout -b my-new-feature)Commit your changes (git commit -am 'Add some feature')Push to the branch (git push origin my-new-feature)Create a new Pull Request","ref":"readme.html#contributing","title":"cased-elixir - Contributing","type":"extras"}]